!macro CustomCodePreInstall
	${GetParent} $INSTDIR $1
	${If} ${FileExists} "$1\FastCopyPortable\App\AppInfo\appinfo.ini"
	${AndIfNot} ${FileExists} "$INSTDIR\App\AppInfo\appinfo.ini"
		Rename "$1\FastCopyPortable\App" "$INSTDIR\App"
		Rename "$1\FastCopyPortable\Data" "$INSTDIR\Data"
		Rename "$1\FastCopyPortable\Other" "$INSTDIR\Other"
		Delete "$1\FastCopyPortable\FastCopyPortable.exe"
		Delete "$1\FastCopyPortable\help.html"
		${If} ${FileExists} "$1\FastCopyPortable\FastCopyPortable.ini"
			Rename "$1\FastCopyPortable\FastCopyPortable.ini" "$INSTDIR\fcpyPortable.ini"
		${EndIf}
		Delete "$INSTDIR\App\AppInfo\Launcher\FastCopyPortable.ini"
		RMDir "$1\FastCopyPortable"
				
		${If} ${FileExists} "$INSTDIR\Data\settings\FastCopyPortableSettings.ini"
			Rename "$INSTDIR\Data\settings\FastCopyPortableSettings.ini" "$INSTDIR\Data\settings\fcpyPortableSettings.ini"
			ReadINIStr $0 "$INSTDIR\Data\settings\fcpyPortableSettings.ini" "FastCopyPortableSettings" "LastDrive"
			WriteINIStr "$INSTDIR\Data\settings\fcpyPortableSettings.ini" "fcpyPortableSettings" "LastDrive" "$0"
			ReadINIStr $0 "$INSTDIR\Data\settings\fcpyPortableSettings.ini" "FastCopyPortableSettings" "LastDirectory"
			WriteINIStr "$INSTDIR\Data\settings\fcpyPortableSettings.ini" "fcpyPortableSettings" "LastDirectory" "$0"
			DeleteINISec "$INSTDIR\Data\settings\fcpyPortableSettings.ini" "FastCopyPortableSettings"
		${EndIf}
	${EndIf}
!macroend

!macro CustomCodePostInstall
	ReadINIStr $0 "$INSTDIR\App\AppInfo\Installer.ini" "DownloadFiles" "DownloadFilename"
	${If} ${FileExists} "$INSTDIR\App\$0"
		nsExec::Exec `"$INSTDIR\App\$0" /silent /extract64 /dir="$INSTDIR\App\FastCopy" /nosubdir`
		Rename "$INSTDIR\App\FastCopy\FastCopy.exe" "$INSTDIR\App\FastCopy\FastCopy64.exe"
		nsExec::Exec `"$INSTDIR\App\$0" /silent /extract32 /dir="$INSTDIR\App\FastCopy" /nosubdir`
		Delete "$INSTDIR\App\$0"
		Delete "$INSTDIR\App\FastCopy\*.dll"
		Delete "$INSTDIR\App\FastCopy\fc*.exe"
		Delete "$INSTDIR\App\FastCopy\setup.exe"
		RMDir /r "$INSTDIR\App\FastCopy\msix"
	${EndIf}
!macroend